SystemOrganization addCategory: #'Xpf-CodeTalk'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Commands'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Core'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Tests'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Morphs'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Models'!

!OBCmdMultiView methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/28/2009 08:46'!
execute
	|viewType|
	viewType := OBChoiceRequest labels: #(Source Bytecode Decompile PrettyPrint Xpf).
	self styler: SHTextStylerST80 new.
	viewType ifNotNil: [self perform: (#toggle, viewType) asSymbol]! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'cs 1/15/2009 17:24'!
styler: styler
	| panel morph |
	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	morph styler: (styler
		view: morph;
		yourself).! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:47'!
toggleXpf

	self styler: XpfTextStyler new.
	self setTextInDefinitionPanel: target source.! !

!String methodsFor: '*xpf-codetalk' stamp: 'mt 5/2/2009 15:52'!
toHex

	^ self
		inject: ''
		into: [:result :char | result, char hex]! !

OBLazyListMorph subclass: #XpfLazyListMorph
	instanceVariableNames: 'showCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfLazyListMorph methodsFor: 'displaying' stamp: 'mt 5/1/2009 16:22'!
display: item  atRow: row on: canvas
	"display the given item at row row"
	| drawBounds top icon node |
	drawBounds := self drawBoundsForRow: row.
	drawBounds := drawBounds intersect: self bounds.
	node := listSource model children at: row.
	
	(listSource backgroundColorAt: row) ifNotNilDo: [:aColor | canvas fillRectangle: drawBounds color: aColor].

	(node isKindOf: OBMethodNode)
		ifTrue: [self indicateMarkupFor: node on: canvas in: drawBounds].
		
	"(node isKindOf: OBClassNode)
		ifTrue: [
			self indicateMarkupForClass: node on: canvas in: drawBounds.
			drawBounds := drawBounds left: drawBounds left + 2 + 6]."
	
	(listSource iconAt: row) ifNotNilDo: 
		[:name |
		icon := OBMorphicIcons iconNamed: name.
		top := drawBounds top + (drawBounds height - icon height // 2).
		canvas translucentImage: icon at: drawBounds left @ top.
		drawBounds := drawBounds left: drawBounds left + icon width + 2].
		
	item isText
		ifTrue: [canvas
			drawString: item
			in: drawBounds
			font: (font emphasized: (item emphasisAt: 1))
			color: (self colorForRow: row).
			drawBounds := drawBounds left: drawBounds left + ((font emphasized: (item emphasisAt: 1)) widthOfString: item)]
		ifFalse: [canvas
			drawString: item
			in: drawBounds
			font: font
			color: (self colorForRow: row).
			drawBounds := drawBounds left: drawBounds left + (font widthOfString: item)].
	
	(node isKindOf: OBMethodNode) "& (row ~= selectedRow)"
		ifTrue: [self
			displayCategoryFor: node
			in: drawBounds
			on: canvas].! !

!XpfLazyListMorph methodsFor: 'displaying' stamp: 'mt 5/2/2009 17:32'!
displayCategoryFor: aMethodNode in: drawBounds on: aCanvas

	self updateProperties.
	aMethodNode theClass == nil ifTrue: [^ self].
	
	showCategories ifTrue: [aCanvas
		drawString: aMethodNode categoryText
		in: drawBounds
		font: font
		color: ((aMethodNode category = 'as yet unclassified')
			ifTrue: [Color red]
			ifFalse: [Color gray])].! !

!XpfLazyListMorph methodsFor: 'displaying' stamp: 'mt 5/2/2009 09:57'!
indicateMarkupFor: aMethodNode on: aCanvas in: drawBounds

	| attrs factor newBounds |
	aMethodNode theClass == nil ifTrue: [^ self].
	
	attrs := (aMethodNode source asText attributesOfKind: XpfComplexAttribute).
	
	attrs ifNotEmpty: [
		factor := ((drawBounds width - 30) // attrs size).
		newBounds := drawBounds topLeft corner: drawBounds bottomRight.
		newBounds := newBounds right: factor].
	attrs withIndexDo: [:attr :index |
		attr displayOn: aCanvas in: newBounds.
		newBounds := newBounds left: factor * index.
		newBounds := newBounds right: factor * (index + 1)].! !

!XpfLazyListMorph methodsFor: 'displaying' stamp: 'mt 4/30/2009 18:16'!
indicateMarkupForClass: aClassNode on: aCanvas in: drawBounds

	| left top icon |
	(aClassNode methods anySatisfy: [:node | node source asText includesAttributesOfKind: XpfComplexAttribute])
		ifTrue: [
			icon := MenuIcons markGoodIcon.
			top := drawBounds top + (drawBounds height - icon height // 2).
			left := drawBounds left - 5.
			aCanvas
				translucentImage: icon
				at: left @ top].! !

!XpfLazyListMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 17:03'!
updateProperties

	showCategories ifNil: [showCategories := 
		(Preferences
			preferenceAt: #showProtocolForMessage
			ifAbsent: [Preference new rawValue: false])
			preferenceValue].! !

!DataStream methodsFor: '*xpf-codetalk' stamp: 'mt 3/24/2009 15:43'!
references

    ^ Dictionary new! !

TestCase subclass: #XpfCtComplexAttributeTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtComplexAttributeTest methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 15:20'!
setUp

	super setUp.
	sut := XpfComplexAttribute forTag: #good.
	sut addChatLine: 'She sells sea shells at the sea shore.'.! !

!XpfCtComplexAttributeTest methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 16:15'!
testInstanceCreation

	self
		should: sut tag = #good;
		should: sut creator = Utilities authorInitials;
		should: sut chat size = 1;
		should: (sut chat first at: #author) = Utilities authorInitials;
		should: sut timestamp <= (sut chat first at: #timestamp)! !

!XpfCtComplexAttributeTest methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 15:35'!
testScanning

	| stream attr |
	stream := (String new: 500) writeStream.
	sut writeScanOn: stream.
	attr := XpfComplexAttribute scanFrom:
		(stream contents readStream position: 1). "Skip first 'h' to identify complex attribute. See RunArray class>>scanFrom:"
	
	self
		should: sut tag = attr tag;
		should: sut timestamp = attr timestamp;
		should: sut creator = attr creator;
		should: sut chat size = attr chat size;
		should: (sut chat first at: #author) = (attr chat first at: #author);
		should: (sut chat first at: #timestamp) = (attr chat first at: #timestamp);
		should: (sut chat first at: #message) = (attr chat first at: #message)! !

TestCase subclass: #XpfCtMonticelloTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtMonticelloTest class methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 13:05'!
markCollectionDoGood

	| source ref |
	ref := MethodReference class: Collection selector: #do:.
	source := ref sourceCode.
	source addAttribute: (XpfComplexAttribute forTag: #good) from: 1 to: 1.
	Collection compile: source classified: ref category.
	^ ref! !

!XpfCtMonticelloTest class methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 12:58'!
markCollectionDoNormal

	| source ref |
	ref := MethodReference class: Collection selector: #do:.
	source := ref sourceCode.
	Collection compile: source asString classified: ref category.
	^ ref! !

!XpfCtMonticelloTest methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 13:05'!
testAddCodeMarkup
	| ref source md snapshotBin md2 color |
	ref := self class markCollectionDoGood.
	source := ref sourceCode.
	color := ((source attributesAt: 1) detect: [:attr | attr isKindOf: XpfComplexAttribute]) color.
	md := (Collection compiledMethodAt: #do:) methodReference asMethodDefinition.
	
	snapshotBin := MCMczWriter new serializeInBinary: (MCSnapshot fromDefinitions: {md}).
	md2 := (DataStream on: ((RWBinaryOrTextStream with: snapshotBin) reset; yourself)) next definitions first.

	self
		should: md2 source isString;
		should: md2 sourceText isText;
		should: md source = md2 source;
		should: ((md2 sourceText attributesAt: 1) anySatisfy: [:attr |
				(attr isKindOf: XpfComplexAttribute) and: [attr color = color]]).
			
	"Clean up"
	self class markCollectionDoNormal.! !

!XpfCtMonticelloTest methodsFor: 'as yet unclassified' stamp: 'mt 4/20/2009 16:17'!
testDefinitionFromReference

	| ref cm md |
	ref := MethodReference class: Collection selector: #do:.
	cm := Collection compiledMethodAt: #do:.
	md := ref asMethodDefinition.
	
	self
		should: cm getSource = ref sourceCode;
		should: ref sourceCode isText;
		should: ref source isString;
		should: md source isString;
		should: md sourceText isText.! !

TestCase subclass: #XpfCtTagSearchTest
	instanceVariableNames: 'sut badText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtTagSearchTest methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 16:39'!
setUp

	super setUp.
	badText := 'int main(int argc, char** args) {printf("%s\n", args[0]);}' asText.
	badText addAttribute: (XpfComplexAttribute forTag: #bad) from: 10 to: 15.
	sut := XpfCtTagSearchHelper new.
	XpfCtMonticelloTest markCollectionDoGood.! !

!XpfCtTagSearchTest methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 16:39'!
tearDown

	super tearDown.
	XpfCtMonticelloTest markCollectionDoNormal.! !

!XpfCtTagSearchTest methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 16:37'!
testBadCode

	sut matchAttributeBad.
	self should: (sut searchText: badText).! !

!XpfCtTagSearchTest methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 16:50'!
testGoodMethodCategory

	sut matchAttributeGood.
	self should: sut results isEmpty.
	sut searchCategory: 'Collections'.
	self shouldnt: sut results isEmpty.
	self should: (sut results anySatisfy: [:ref |
		ref classIsMeta not &
		(ref classSymbol = #Collection) &
		(ref methodSymbol = #do:)]).! !

!XpfCtTagSearchTest methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 16:39'!
testGoodMethodClass

	sut matchAttributeGood.
	self should: sut results isEmpty.
	sut searchClass: Collection.
	self
		should: sut results size = 1;
		shouldnt: sut results first classIsMeta;
		should: sut results first classSymbol = #Collection;
		should: sut results first methodSymbol = #do:.! !

!XpfCtTagSearchTest methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 16:57'!
testGoodMethodGlobal

	sut matchAttributeGood.
	self should: sut results isEmpty.
	sut searchGlobal.
	self shouldnt: sut results isEmpty.
	self should: (sut results anySatisfy: [:ref |
		ref classIsMeta not &
		(ref classSymbol = #Collection) &
		(ref methodSymbol = #do:)]).! !

TestCase subclass: #XpfCtTextTest
	instanceVariableNames: 'sut att1 att2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtTextTest methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 10:23'!
setUp
	
	super setUp.
	
	sut := 'The quick brown fox jumps over the lazy dog.' asText.
	att1 := XpfComplexAttribute forTag: #good.
	att2 := XpfComplexAttribute forTag: #bad.! !

!XpfCtTextTest methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 10:19'!
testAttributesOfKind

	| atts |
	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	
	atts := sut attributesOfKind: att1 class.
	
	self
		should: atts size = 2;
		should: atts first == att1;
		should: atts second == att2.! !

!XpfCtTextTest methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 10:22'!
testAttributesOfKindFromTo

	| atts1 atts2 atts3 atts4 |
	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	
	atts1 := sut attributesOfKind: att1 class from: 1 to: 5.
	atts2 := sut attributesOfKind: att2 class from: 6 to: 10.
	atts3 := sut attributesOfKind: att1 class from: 1 to: 10.
	atts4 := sut attributesOfKind: att1 class from: 5 to: 5.
	
	self
		should: atts1 size = 1;
		should: atts2 size = 1;
		should: atts3 size = 2;
		should: atts4 size = 1;
		should: atts1 first == att1;
		should: atts2 first == att2;
		should: atts3 first == att1;
		should: atts3 second == att2;
		should: atts4 first == att1.! !

!XpfCtTextTest methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 10:24'!
testIncludesAttributesOfKind

	sut addAttribute: att1 from: 1 to: 1.
	self should: (sut includesAttributesOfKind: att1 class).! !

!XpfCtTextTest methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 10:27'!
testRemoveAttribute

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!XpfCtTextTest methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 10:28'!
testRemoveAttributeAround

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1 around: 5.
	sut removeAttribute: att2 around: 5.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!XpfCtTextTest methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 10:30'!
testRemoveAttributeAroundAnd

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1 around: 4 and: 6.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!XpfCtTextTest methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 10:32'!
testRemoveAttributeFromTo

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1 from: 1 to: 5.
	sut removeAttribute: att2 from: 6 to: 9.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:00'!
attributesOfKind: anAttrClass
	"Return a collection with all instances of the given attribute class that can be found in this text."
	
	| result |
	result := OrderedCollection new.
	runs values do: [:array |
		array do: [:attr | (attr isKindOf: anAttrClass)
			ifTrue: [result addIfNotPresent: attr]]].
	^ result! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 14:18'!
attributesOfKind: anAttrClass from: start to: stop
	"Return a collection with all instances of the given attribute class that can be found in the specified range."
	
	| part result |
	result := OrderedCollection new.
	part := self copyFrom: start to: stop.
	part runs withStartStopAndValueDo: [:i :j :attributes |
		result addAll: (attributes select: [:attr | attr isKindOf: anAttrClass])].
	^ result.! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 14:01'!
includesAttributesOfKind: anAttrClass
	"Check whether this text has at least one run that includes an attribute of the given class."
	
	runs values do: [:array |
		array do: [:attr | (attr isKindOf: anAttrClass) ifTrue: [^ true]]].
	^ false! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:08'!
removeAttribute: attr
	
	self removeAttribute: attr from: 1 to: self size.! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 13:56'!
removeAttribute: anAttribute around: index
	
	self removeAttribute: anAttribute around: index and: index.! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 15:08'!
removeAttribute: anAttribute around: leftIndex and: rightIndex
	"Remove the given attribute from all indices that are adjacent to the given ones."

	| start stop |
	start := leftIndex.
	[start > 0 and: [(self attributesAt: start) includes: anAttribute]]
		whileTrue: [start := start - 1].
	stop := rightIndex.
	[stop <= self size and: [(self attributesAt: stop) includes: anAttribute]]
		whileTrue: [stop := stop + 1].

	self removeAttribute: anAttribute from: (start max: 0) to: (stop min: runs size).! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:08'!
removeAttribute: attr from: start to: stop
	"Removes an attribute kind over the interval start to stop."
	
	runs := runs
		copyReplaceFrom: start
		to: stop
		with: ((runs copyFrom: start to: stop)	mapValues:
			[:attributes | attributes reject: [:each | each = attr]])! !

PanelMorph subclass: #XpfCtCodeChatMorph
	instanceVariableNames: 'model chatLog textEntry addMessageButton closeButton title1 title2 title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtCodeChatMorph class methodsFor: 'constants' stamp: 'mt 4/30/2009 08:23'!
defaultExtent

	^ 200@150! !

!XpfCtCodeChatMorph class methodsFor: 'instance creation' stamp: 'mt 5/2/2009 16:42'!
forAttribute: anXpfAttribute

	^ self new
		attribute: anXpfAttribute! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 18:02'!
addMessageButton

	addMessageButton ifNil: [addMessageButton := IconicButton new
			color: Color transparent;
			target: self textEntry;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCtCommentAddIcon;
			actionSelector: #accept;
			setBalloonText: 'Add message'].
	^ addMessageButton! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 17:00'!
attribute: anXpfAttribute

	self model ifNil: [^ self].
	self model attribute: anXpfAttribute.
	self title contents: ('{1} - {2}' format: {
			anXpfAttribute timestamp printRelativeTimeStamp.
			anXpfAttribute creator}).! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 18:38'!
chatLog

	chatLog ifNil: [chatLog := (UITheme current
		newMorphListIn: self
		for: self model
		list: #messages
		getSelected: #lastIndex
		setSelected: nil
		getEnabled: nil
		help: 'Let''s talk about code...')
		hResizing: #rigid;
		vResizing: #rigid;
		cellInset: 0;
		layoutInset: 0;
		borderWidth: 0;
		fillStyle: Color transparent;
		extent: self class defaultExtent.
		chatLog listMorph cellInset: 0].
	^ chatLog! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 18:02'!
closeButton

	closeButton ifNil: [closeButton := IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCtCrossIcon;
			actionSelector: #delete;
			setBalloonText: 'Close chat window'].
	^ closeButton! !

!XpfCtCodeChatMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 16:51'!
initialize

	super initialize.
	self
		"extent: self class defaultExtent;"
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		borderWidth: 1;
		borderColor: Color black;
		changeTableLayout;
		fillStyle: (Color yellow alpha: 0.8);
		layoutInset: 5;
		cellInset: 5;
		useRoundedCorners;
		addMorphBack: (UITheme current newRowIn: self for: {
			self title.
			self closeButton});
		addMorphBack: self chatLog;
		addMorphBack: (UITheme current newRowIn: self for: {
			self textEntry.
			self addMessageButton}).! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:10'!
model

	model ifNil: [model := XpfCtCodeChatModel new].
	^ model! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 18:06'!
textEntry

	textEntry ifNil: [textEntry := UITheme current
		newTextEntryIn: self
		for: self model
		get: #newMessage
		set: #addMessage:
		class: String
		getEnabled: nil
		help: nil].
	^ textEntry! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 17:00'!
title

	title ifNil: [title := UITheme current
			newLabelIn: self label: 'Code Chat'.
		title hResizing: #spaceFill].
	^ title! !

PanelMorph subclass: #XpfCtMessageMorph
	instanceVariableNames: 'timestamp author message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtMessageMorph class methodsFor: 'instance creation' stamp: 'mt 4/30/2009 09:04'!
timestamp: aTimeStamp author: aString message: messageString

	^ self new
		author: aString;
		timestamp: aTimeStamp;
		message: messageString! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:03'!
author

	author ifNil: [author := ''].
	^ author! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:04'!
author: aString

	author := aString! !

!XpfCtMessageMorph methodsFor: 'initialization' stamp: 'mt 5/2/2009 11:39'!
initialize

	super initialize.
	self
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		borderWidth: 0;
		layoutInset: 4;
		cellInset: 0;
		fillStyle: Color white;
		width: XpfCtCodeChatMorph defaultExtent x;
		initializeUserInterface.! !

!XpfCtMessageMorph methodsFor: 'initialization' stamp: 'mt 4/30/2009 09:04'!
initializeUserInterface

	self
		addMorphBack: self timestamp;
		addMorphBack: self message.! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 11:33'!
message

	message ifNil: [message := TextMorph new
		hResizing: #spaceFill;
		vResizing: #rigid;
		lock].
	^ message! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 11:36'!
message: aString

	self message contentsWrapped: aString asText.
	self message font: (XpfClient sansFontAt: 10).! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:24'!
timestamp

	timestamp ifNil: [timestamp := TextMorph new
		hResizing: #spaceFill;
		vResizing: #rigid;
		lock].
	^ timestamp! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 18:19'!
timestamp: aTimeStamp

	| text |
	text := '{1} - {2}:' format: {aTimeStamp printRelativeTimeStamp. self author}.
	self timestamp contents: text.
	self timestamp font: ((XpfClient sansFontAt: 8) emphasized: (TextEmphasis bold emphasisCode)).
	! !

PanelMorph subclass: #XpfCtRowMorph
	instanceVariableNames: 'lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfCtRowMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 17:18'!
for: someMorphs

	| instance |
	instance := self new.
	someMorphs do: [:m | instance addMorphBack: m].
	^ instance! !

!XpfCtRowMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 10:10'!
initialize

	super initialize.
	self
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		layoutInset: 3;
		useRoundedCorners;
		cellInset: 3;
		color: (Color r: 4 g: 133 b: 157 alpha: 0.9).! !

!XpfCtRowMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 17:26'!
position: aPoint

	aPoint = lastPosition ifTrue: [^ self].
	lastPosition := aPoint.
	super position: aPoint.! !

Object subclass: #XpfCodeTalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfCodeTalk class methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 09:27'!
initialize
	"Resend this message whenever you checkout a new version of CodeTalk."
	
	super initialize.
	self
		initializeMonticello;
		initializePreferences;
		initializeOtherClasses.! !

!XpfCodeTalk class methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 09:26'!
initializeMonticello

	(MCMethodDefinition allInstVarNames includes: #sourceText)
		ifFalse:[MCMethodDefinition addInstVarName: #sourceText].! !

!XpfCodeTalk class methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 09:27'!
initializeOtherClasses
	
	(Smalltalk includesKey: #XpfEditor)
		ifTrue: [XpfEditor initializeCmdKeyShortcuts].
		
	(Smalltalk includesKey: #XpfComplexAttribute)
		ifTrue: [XpfComplexAttribute reset].! !

!XpfCodeTalk class methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 11:38'!
initializePreferences
		
	(Preferences dictionaryOfPreferences includesKey: #showLineNumbers)
		ifFalse: [Preferences
			addBooleanPreference: #showLineNumbers
			category: #CodeTalk
			default: false
			balloonHelp: 'Enables line numbers in front of each codeline.'].
		
	(Preferences dictionaryOfPreferences includesKey: #showProtocolForMessage)
		ifFalse: [Preferences
			addBooleanPreference: #showProtocolForMessage
			category: #CodeTalk
			default: false
			balloonHelp: 'Displays the protocol name after each message name in the code browser.'].
		
	Preferences setPreference: #confirmFirstUseOfStyle toValue: false.
	Preferences setPreference: #alwaysShowVScrollbar toValue: false.! !

!XpfCodeTalk methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 15:37'!
todo

	"Feature chat: here."! !

Object subclass: #XpfCtCodeChatModel
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtCodeChatModel methodsFor: 'adding' stamp: 'mt 5/1/2009 19:07'!
addMessage: aMessage

	aMessage ifEmpty: [^ self].
	self attribute ifNil: [^ self].
	self attribute addChatLine: aMessage.
	self
		changed: #messages;
		changed: #newMessage;
		changed: #lastIndex.! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:22'!
attribute

	^ attribute! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:22'!
attribute: anXpfComplexAttribute

	attribute := anXpfComplexAttribute.
	self changed: #messages.! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/1/2009 18:39'!
lastIndex
	"Used to show the latest message"
	
	self attribute ifNil: [^ 0].
	^ self attribute chat size! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:21'!
messages

	self attribute ifNil: [^ #()].
	
	^ self attribute chat collect: [:line | XpfCtMessageMorph
		timestamp: (line at: #timestamp)
		author: (line at: #author)
		message: (line at: #message)]! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/1/2009 18:07'!
newMessage

	^ ''! !

Object subclass: #XpfCtTagSearchHelper
	instanceVariableNames: 'results classMatchers methodMatchers attributeMatchers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 16:43'!
addAttributeMatcher: matcher

	self attributeMatchers add: matcher.! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 16:43'!
addMethodMatcher: matcher

	self methodMatchers add: matcher.! !

!XpfCtTagSearchHelper methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 15:29'!
addToResultClass: mrClass symbol: mrSel

	self pvtResults add: (MethodReference new
		setStandardClass: mrClass
		methodSymbol: mrSel).! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 15:31'!
attributeMatchers

	^ attributeMatchers! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 15:31'!
attributeMatchers: anObject

	attributeMatchers := anObject.! !

!XpfCtTagSearchHelper methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 16:47'!
initialize

	self
		methodMatchers: OrderedCollection new;
		attributeMatchers: OrderedCollection new;
		results: Set new;
		addMethodMatcher: [:sel | sel isDoIt not]! !

!XpfCtTagSearchHelper methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 15:27'!
matchAttributeBad

	self addAttributeMatcher: [:att | att tag = #bad].! !

!XpfCtTagSearchHelper methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 15:45'!
matchAttributeGood

	self addAttributeMatcher: [:att | att tag = #good].! !

!XpfCtTagSearchHelper methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 15:45'!
matchAttributeTalk

	self addAttributeMatcher: [:att | att tag = #talk].! !

!XpfCtTagSearchHelper methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 15:45'!
matchAttributeUnclear

	self addAttributeMatcher: [:att | att tag = #unclear].! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 15:45'!
methodMatchers

	^ methodMatchers! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 15:46'!
methodMatchers: anObject

	methodMatchers := anObject.! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 13:06'!
pvtResults

	^ results! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 13:07'!
results

	^ results asSortedCollection! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 12:39'!
results: anObject

	results := anObject.! !

!XpfCtTagSearchHelper methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 15:42'!
searchAttribute: anAttribute
	"Attribute matchers are considered to be disjunctive"
	
	self attributeMatchers do: [ :matcher |
		(matcher value: anAttribute) ifTrue: [^ true]].
	^ false! !

!XpfCtTagSearchHelper methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 16:57'!
searchCategory: aString

	| result |
	result := OrderedCollection new.
	Smalltalk organization categories
		select: [:c | c startsWith: aString]
		thenDo: [:c | result addAll: (Smalltalk organization listAtCategoryNamed: c)].
	result
		do: [:name | self searchClass: (Smalltalk at: name)]
		displayingProgress: 'Searching category ', aString, '...'.! !

!XpfCtTagSearchHelper methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 16:37'!
searchClass: class

	class selectorsDo: [:sel |
		(self searchMethod: sel text: (class sourceCodeAt: sel))
			ifTrue: [self addToResultClass: class symbol: sel]].! !

!XpfCtTagSearchHelper methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 13:09'!
searchGlobal

	| count |
	'Searching all source code...'
		displayProgressAt: Sensor cursorPoint
		from: 0 to: Smalltalk classNames size
		during: [:bar |
			count := 0.
			SystemNavigation default allBehaviorsDo: [:each |
				bar value: (count := count + 1).
				self searchClass: each]].! !

!XpfCtTagSearchHelper methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 16:56'!
searchMethod: sel text: text
	
	text isText ifFalse: [^ false].
	self methodMatchers do: [:matcher |
		(matcher value: sel) ifFalse: [^ false]].
	^ self searchText: text! !

!XpfCtTagSearchHelper methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 16:45'!
searchText: aText

	aText runs values do: [:atts |
		atts
			do: [:att |
				((att isKindOf: XpfComplexAttribute)
				and: [self searchAttribute: att])
					ifTrue: [^ true]]].
	^ false! !

OBTextMorphEditorWithShout subclass: #XpfEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfEditor class methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:36'!
initializeCmdKeyShortcuts
	super initializeCmdKeyShortcuts.
	CmdActions
		at: ($q asInteger + 1) put: #markAsGood:;
		at: ($r asInteger + 1) put: #markAsBad:;
		at: ($t asInteger + 1) put: #markAsUnclear:;
		at: ($w asInteger + 1) put: #removeMarkup:.
	
! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 13:44'!
changeParagraph: aParagraph
	"Add a back reference to the textmorph to the paragraph."

	super changeParagraph: aParagraph.
	(aParagraph isKindOf: XpfParagraph) & (morph isKindOf: XpfTextMorph)
		ifTrue: [
			aParagraph textMorph: morph.
			morph removeAllMorphs.
			(aParagraph text attributesOfKind: XpfComplexAttribute)
				do: [:attr | attr addDependent: morph]].! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 09:34'!
justTalk: aCharacterStream

	paragraph tagSelectionWith: #talk.
	self userHasEdited.
	^ true! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 15:59'!
markAsBad: aCharacterStream

	(paragraph tagSelectionWith: #bad)
		ifTrue: [self userHasEdited. ^ true].
	^ false! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 14:46'!
markAsGood: aCharacterStream

	paragraph tagSelectionWith: #good.
	self userHasEdited.
	^ true! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 15:09'!
markAsUnclear: aCharacterStream

	paragraph tagSelectionWith: #unclear.
	self userHasEdited.
	^ true! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 14:55'!
removeMarkup: aCharacterStream

	paragraph untagSelection.
	self userHasEdited.
	^ true! !

SHTextStylerST80 subclass: #XpfTextStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfTextStyler methodsFor: 'private' stamp: 'mt 4/29/2009 23:01'!
privateStyle: aText
	"First, backup current style information about background color in text runs. Then let Shout work. Then restore background color information for text runs."

	| backupRuns |
	backupRuns := aText runs.

	super privateStyle: aText.
	
	backupRuns withStartStopAndValueDo: [:start :stop :attrs | |a|
		a := attrs detect: [:attr | attr isKindOf: XpfComplexAttribute] ifNone: [nil].
		a ifNotNil: [aText addAttribute: a from: start to: stop].
	]! !

!XpfTextStyler methodsFor: 'as yet unclassified' stamp: 'mt 4/29/2009 23:02'!
unstyledTextFrom: aText

	| backupRuns result |
	backupRuns := aText runs.

	result := super unstyledTextFrom: aText.
	
	backupRuns withStartStopAndValueDo: [:start :stop :attrs | |a|
		a := attrs detect: [:attr | attr isKindOf: XpfComplexAttribute] ifNone: [nil].
		a ifNotNil: [result addAttribute: a from: start to: stop]].
	^ result! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'mt 5/1/2009 15:54'!
cmdCodeTalk
	^ XpfCtCommand allSubclasses! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 4/26/2009 21:50'!
categoryText

	^ (' ({1})' format: {self category}) asText addAttribute: (TextColor color: Color gray)! !

!OBPluggableListMorph methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/26/2009 21:32'!
listMorphClass
    ^XpfLazyListMorph! !

ImageMorph subclass: #XpfCtAttributeIconMorph
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfCtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 17:19'!
attribute
	^ attribute! !

!XpfCtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 17:19'!
attribute: anObject
	attribute := anObject! !

!XpfCtAttributeIconMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 17:19'!
handlesMouseDown: evt

	^ true! !

XpfCtAttributeIconMorph subclass: #XpfCtChatIconMorph
	instanceVariableNames: 'chat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfCtChatIconMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:16'!
balloonText

	^ 'View chat'! !

!XpfCtChatIconMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 14:49'!
chat

	chat ifNil: [chat := XpfCtCodeChatMorph forAttribute: self attribute].
	^ chat! !

!XpfCtChatIconMorph methodsFor: 'initialization' stamp: 'mt 5/1/2009 17:55'!
initialize

	super initialize.
	self image: (MenuIcons xpfCtCommentsIcon).! !

!XpfCtChatIconMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 15:18'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self chat
		initialize;
		position: self positionInWorld;
		attribute: self attribute;
		openInWorld.! !

XpfCtAttributeIconMorph subclass: #XpfCtDeleteIconMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfCtDeleteIconMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 15:16'!
balloonText

	^ 'Delete markup'! !

!XpfCtDeleteIconMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 17:55'!
initialize

	super initialize.
	self image: (MenuIcons xpfCtDeleteIcon).! !

!XpfCtDeleteIconMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 17:55'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute requestDeletion.! !

!OBPluggableTextMorphWithShout class methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/1/2009 15:45'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel
	"CodeTalk: Use the XpfStyler right now."
	
	|styler answer stylerClass |
	answer := self new.
	stylerClass := answer stylerClass.
	styler := stylerClass
		ifNotNil:[
			stylerClass new
				view: answer;
				yourself].
	^ answer
		styler: styler;
		on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: getSelectionSel
		menu: getMenuSel! !

!OBPluggableTextMorphWithShout methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:48'!
stylerClass
	^XpfTextStyler! !

!OBPluggableTextMorphWithShout methodsFor: '*xpf-codetalk-override' stamp: 'topa 2/13/2009 13:48'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	^XpfTextMorph! !

OBTextMorphWithShout subclass: #XpfTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 14:13'!
addMorph: aMorph

	(self submorphs includes: aMorph)
		ifFalse: [^ super addMorph: aMorph].
	^ aMorph! !

!XpfTextMorph methodsFor: 'private' stamp: 'topa 2/13/2009 14:09'!
editorClass
	"Answer the class used to create the receiver's editor"
	
	^XpfEditor! !

!XpfTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/30/2009 10:36'!
initialize

	super initialize.
	
	(Preferences preferenceAt: #showLineNumbers ifAbsent: [Preference new rawValue: false]) preferenceValue
		ifTrue: [self leftMargin: ((Preferences standardCodeFont widthOfString: '99') * 1.7) rounded].! !

!XpfTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/29/2009 15:52'!
leftMargin: aNumber

	self margins: (aNumber@0 corner: 0@0).! !

!XpfTextMorph methodsFor: 'private' stamp: 'mt 4/22/2009 20:24'!
paragraphClass
	
	^ XpfParagraph! !

!XpfTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/30/2009 14:38'!
removeAllMorphsBut: someMorphs

	self submorphs copy do: [:m | (someMorphs includes: m)
		ifFalse: [m delete]]! !

!XpfTextMorph methodsFor: 'private' stamp: 'mt 4/30/2009 17:06'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #chatLineAdded ifTrue: [self hasUnacceptedEdits: true].! !

!XpfTextMorph methodsFor: 'private' stamp: 'mt 5/1/2009 17:45'!
update: aSymbol with: anAttribute

	aSymbol = #deleteRequested ifTrue: [
		self text removeAttribute: anAttribute.
		self hasUnacceptedEdits: true].
	
	super update: aSymbol with: anAttribute.! !

!XpfTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/30/2009 13:21'!
updateSubmorphs: someMorphs

	self submorphs copy do: [:m |
		(someMorphs includes: m) ifFalse: [m delete]].
	someMorphs do: [:m |
		(self submorphs includes: m) ifFalse: [self addMorph: m]].! !

!RunArray class methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/30/2009 11:37'!
scanFrom: strm
	"Read the style section of a fileOut or sources file.  nextChunk has already been done.  We need to return a RunArray of TextAttributes of various kinds.  These are written by the implementors of writeScanOn:"
	| rr vv aa this |
	(strm peekFor: $( ) ifFalse: [^ nil].
	rr := OrderedCollection new.
	[strm skipSeparators.
	 strm peekFor: $)] whileFalse: 
		[rr add: (Number readFrom: strm)].
	vv := OrderedCollection new.	"Value array"
	aa := OrderedCollection new.	"Attributes list"
	[(this := strm next) == nil] whileFalse: [
		this == $, ifTrue: [vv add: aa asArray.  aa := OrderedCollection new].
		this == $a ifTrue: [aa add: 
			(TextAlignment new alignment: (Integer readFrom: strm))].
		this == $f ifTrue: [aa add: 
			(TextFontChange new fontNumber: (Integer readFrom: strm))].
		this == $F ifTrue: [aa add: (TextFontReference toFont: 
			(StrikeFont familyName: (strm upTo: $#) size: (Integer readFrom: strm)))].
		this == $b ifTrue: [aa add: (TextEmphasis bold)].
		this == $i ifTrue: [aa add: (TextEmphasis italic)].
		this == $u ifTrue: [aa add: (TextEmphasis underlined)].
		this == $= ifTrue: [aa add: (TextEmphasis struckOut)].
		this == $n ifTrue: [aa add: (TextEmphasis normal)].
		this == $- ifTrue: [aa add: (TextKern kern: -1)].
		this == $+ ifTrue: [aa add: (TextKern kern: 1)].
		this == $c ifTrue: [aa add: (TextColor scanFrom: strm)]. "color"
		this == $h ifTrue: [aa add: (XpfComplexAttribute scanFrom: strm)]. "background color - CodeTalk"
		this == $L ifTrue: [aa add: (TextLink scanFrom: strm)].	"L not look like 1"
		this == $R ifTrue: [aa add: (TextURL scanFrom: strm)].
				"R capitalized so it can follow a number"
		this == $q ifTrue: [aa add: (TextSqkPageLink scanFrom: strm)].
		this == $p ifTrue: [aa add: (TextSqkProjectLink scanFrom: strm)].
		this == $P ifTrue: [aa add: (TextPrintIt scanFrom: strm)].
		this == $d ifTrue: [aa add: (TextDoIt scanFrom: strm)].
		"space, cr do nothing"
		].
	aa size > 0 ifTrue: [vv add: aa asArray].
	^ self runs: rr asArray values: vv asArray
"
RunArray scanFrom: (ReadStream on: '(14 50 312)f1,f1b,f1LInteger +;i')
"! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markBadIcon
	^ Icons
			at: #'markBad'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markBadIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:06'!
markBadIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAACxSURBVDjL7dItC8JQAIXh491H
WbDvD1pEDIIKm1zDxqKi0WIULAZFYc1msF3ErEZlMC9Mhxx/gTAR28KpDxx4QRK/DCXwAbDg
0oLMTShtQF0F5AlwvwHkqy+Zxxs+lwsmvs8DKrIw8DCh8njNLOxRtxrU4yF3MFRhIBFQ2XxG
3W7yXq8xjULGsIsDFwF58zzq0YBpFPDc6XIKp/iFI4S7h5BbWGoFW03gyABVtyzxT8Ab8Xze
i+tkcykAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markGoodIcon
	^ Icons
			at: #'markGood'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markGoodIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:06'!
markGoodIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAC5SURBVDjLY/j//z8DJZhh1ADs
BjjsspIC4gb77ZZX7TdbXLVda9Zgs8xEihQDGmZfm/7/0KOD/3ff3/V/6plJ/y3mGjYQbYD9
NsurBx4e+D/10tT/nWc6/i+5sui/+RS9q0QbYLfB/OrWO1v+d5/p+t96qvn/3Auz/pt0aRNv
gPVyk4appyf+X3xl4f/ZF2b+n3Co579+mSrxXrCcZyhlMV2/wbRP56pRq+ZV3SLlBq1EOanR
lEgjAwAXIuIDq5qm/AAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markUnknownIcon
	^ Icons
			at: #'markUnknown'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markUnknownIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:07'!
markUnknownIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAABlSURBVCjPY/jPgB8yDC4FilKK
DfJXZa6KNwhKYVfQkPW/63/b/+T/XA1YFchd7fqf/j/2f+N/5qtYFUhe7fif9D/sf91/BuwK
hBoS/jcBpcP/M2C3gluKrYHhKhA2MEgN2pDEDgEb0f5zlvXgVgAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
removeMarkupIcon
	^ Icons
			at: #'removeMarkup'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self removeMarkupIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:07'!
removeMarkupIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAABbSURBVCjPzdAxDoAgEERRzsFp
95JbGI2ASA2SCOX3Ahtr8tuXTDIO959bCxRfpOitWS5vA+lMJg9JbKCTTmMQ1QS3ThqVQbBB
lsbgpXLYE8lHCXrqLptf9km7Dzv+FwGTaznIAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:52'!
xpfCtCommentAddContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAGkSURBVDjLrZJPKINhHMd3UsrJ
TcpBDi6UC+3ookQ5OOBAaCh2cFQ40GqTzURTihI54DRp8dqBg3BQw5BtNmxe/4flT9re5+v3
vJvF2l6Kp749Pe/7fj7P7/09jwqA6i9R/ZugVr+cSZmlvFOgEIGSl0xgnVt3IRyRoDSWtn1c
4qakxQW0yKBEJMbw+MpwHWIQnxgCDwxnQQbvHYP7RoLnJirvntrkkuKvghytZU1+eUWg+Mjg
J/j0nuEkBh9dSTgQo4KB+R0uqEgquCD4PBiDbxlc11HYSfBuILUg/gu8fB/t6rmVcEzw4aWE
fYIdAS6IyILe6S0uUCdtIpd8Hbwah1+SxQlNTE91jJHPI5tcPoiLrBsL6BxrQOtQFep0pc/l
XYU9P14kkngugy/onxlF30ITlpwWOEQB5tV21JgLUNKRZVSCTeM2J6/kuV5fFrbuD8N6OCJX
Y7S3wGxv44K3VHAuxUvR8HVldxFszolvvVncs3DB7+67Wpv9Nig0Qy80yrB+pVG5gsTQh7pq
Yz5Mgkbemc98rdiDJBIDJcTLjs0G/vwDCw/6dFwBuzsAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:53'!
xpfCtCommentAddIcon
	^ Icons
			at: #'xpfCtCommentAdd'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtCommentAddContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:51'!
xpfCtCommentsContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAG/SURBVDjLjZK9T8JQFMVZTUyc
3IyJg4mDi87+GyYu6qB/gcZdFxkkJM66qJMGSNRBxDzigJMRQ1jQ4EcQ+SgVKB+FtuL13EdJ
xNDq8Ev7Xu85797T51nwhqeAH5w6cAxWwDgReX7jwYfdaCIraroptB7NLlVQrOoiGEsL1G06
GZyxuILicsMUH3VTlOqGKNUMUdTacj+j1Nng0NGAT2WxYosK1bbIVVoiW27J9V8G57WWKVSc
zMV5iK+Tudv1vVh5yXdlLQN+os4AFZss2Ob82CCgQmhYHSnmkzf2b6rIhTAaaT2aXZALIRdC
LgRtkA1WfYG4iKcVYX52JIs7EYvFmJ8wGiEXQi6EXAhdyn2MxQaPcg68zIETTvzyLsPzWnwq
ixVbhFwI3RFykes+A9vkIBKX4jCoIxdCLrI4/0OcUXXK4/1dbbDBS088xGGCCzAJCsiF2lan
T8xdKNhHXvRarLFBqmcwCrbAhL32+kP3lHguETKRsNlbqUFPeY2OoikW62DNM+jf2ibzQNN0
g5ALC75AGiT59oIReQ+cDGyTB+TC4jaYGXiRXMTD3AFogVmnOjeDMRAC025duo7wH74BwZ8J
lHrTPLcAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:54'!
xpfCtCommentsIcon
	^ Icons
			at: #'xpfCtComments'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtCommentsContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:52'!
xpfCtCrossContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAIhSURBVDjLlZPrThNRFIWJicmJ
z6BWiYbIkYDEG0JbBiitDQgm0PuFXqSAtKXtpE2hNuoPTXwSnwtExd6w0pl2OtPlrphKLSXh
x07OZM769qy19wwAGLhM1ddC184+d18QMzoq3lfsD3LZ7Y3XbE5DL6Atzuyilc5Ciyd7IHVf
gNcDYTQ2tvDr5crn6uLSvX+Av2Lk36FFpSVENDe3OxDZu8apO5rROJDLo30+Nlvj5RnTlVNA
Ks1aCVFr7b4BPn6Cls21AWgEQlz2+Dl1h7IdA+i97A/geP65WhbmrnZZ0GIJpr6OqZqYAd5/
gJpKox4Mg7pD2YoC2b0/54rJQuJZdm6Izcgma4TW1WZ0h+y8BfbyJMwBmSxkjw+VObNanp5h
/adwGhaTXF4NWbLj9gEONyCmUZmd10pGgf1/vwcgOT3tUQE0DdicwIod2EmSbwsKE1P8QoDk
cHPJ5YESjgBJkYQpIEZ2KEB51Y6y3ojvY+P8XEDN7uKS0w0ltA7QGCWHCxSWWpwyaCeLy0Bk
A7UXyyg8fIzDoWHeBaDN4tQdSvAVdU1Aok+nsNTipIEVnkywo/FHatVkBoIhnFisOBoZxcGt
Qd4B0GYJNZsDSiAEadUBCkstPtN3Avs2Msa+Dt9XfxoFSNYF/Bh9gP0bOqHLAm2WUF1YQskw
rVFYPWkf3h1iXwbvqGfFPSGW9Eah8HSS9fuZDnS32f71m8KFY7xs/QZyu6TH2+2+FAAAAABJ
RU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:54'!
xpfCtCrossIcon
	^ Icons
			at: #'xpfCtCross'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtCrossContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:52'!
xpfCtDeleteContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJdSURBVDjLpZP7S1NhGMf9W7Yf
ogSJboSEUVCY8zJ31trcps6zTI9bLGJpjp1hmkGNxVz4Q6ildtXKXzJNbJRaRmrXoeWx8tJO
TWptnrNryre5YCYuI3rh+8vL+/m8PA/PkwIg5X+y5mJWrxfOUBXm91QZM6UluUmthntHqplx
Uml2lciF6wrmdHriI0Wx3xw2hAediLwZRWRkCPzdDswaSvGqkGCfq8VEUsEyPF1O8Qu3O7A0
9RbRvjuIttsRbT6HHzebsDjcB4/JgFFlNv9MnkmsEszodIIY7Oaut2OJcSF68Qx8dgv8tmqE
L1gQaaARtp5A+N4NzB0lMXxon/uxbI8gIYjB9HytGYuusfiPIQcN71kjgnW6VeFOkgh3XcHL
vAwMSDPohOADdYQJdF1FtLMZPmslvhZJk2ahkgRvq4HHUoWHRDqTEDDl2mDkfheiDgt8pw34
0/EocuClCuFvboQzb0cwIZgki4KhzlaE6w0InipbVzBfqoK/qRH94i0rgokSFeO11iBkp8Ed
V8cfJo0yD75aE2ZNRvSJ0lZKcBXLaUYmQrCzDT6tDN5SyRqYlWeDLZAg0H4JQ+Jt6M3atNLE
10VSwQsN4Z6r0CBwqzXesHmV+BeoyAUri8EyMfi2FowXS5dhd7doo2DVII0V5BAjigP89GEV
Atda8b2ehodU4rNaAW+dGfzlFkyo89GTlcrHYCLpKD+V7yeeHNzLjkp24Uu1Ed6G8/F8qjqG
Rzlbl2H2dzjpMg1KdwsHxOlmJ7GTeZC/nesXbeZ6c9OYnuxUc3fmBuFft/Ff8xMd0s65SXIb
/gAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:54'!
xpfCtDeleteIcon
	^ Icons
			at: #'xpfCtDelete'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtDeleteContents readStream) ].! !

!MCMethodDefinition class methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/20/2009 15:54'!
forMethodReference: aMethodReference
	"CodeTalk: Get the markup from the method reference and put it into the definition."

	| definition |
	definition := self cachedDefinitions at: aMethodReference compiledMethod ifAbsent: [].
	(definition isNil
		or: [definition selector ~= aMethodReference methodSymbol]
		or: [definition className ~= aMethodReference classSymbol]
		or: [definition classIsMeta ~= aMethodReference classIsMeta]
		or: [definition category ~= aMethodReference category])
			ifTrue: [definition := (self 
						className: aMethodReference classSymbol
						classIsMeta: aMethodReference classIsMeta
						selector: aMethodReference methodSymbol
						category: aMethodReference category
						timeStamp: aMethodReference timeStamp
						source: aMethodReference source)
						sourceText: aMethodReference sourceCode.
					self cachedDefinitions at: aMethodReference compiledMethod put: definition].
	^ definition
	! !

!MCMethodDefinition methodsFor: '*xpf-codetalk-override' stamp: 'cs 4/17/2009 18:23'!
addMethodAdditionTo: aCollection
	| methodAddition |
	methodAddition := MethodAddition new
		compile: self sourceText
		classified: category
		withStamp: timeStamp
		notifying: (SyntaxError new category: category)
		logSource: true
		inClass: self actualClass.
	"This might raise an exception and never return"
	methodAddition createCompiledMethod.
	aCollection add: methodAddition.
! !

!MCMethodDefinition methodsFor: '*xpf-codetalk-override' stamp: 'cs 4/17/2009 18:24'!
load
	self actualClass
		compile: self sourceText
		classified: category
		withStamp: timeStamp
		notifying: (SyntaxError new category: category)! !

!MCMethodDefinition methodsFor: '*xpf-codetalk' stamp: 'cs 4/20/2009 16:16'!
sourceText

	^ sourceText ifNil: [self source asText]! !

!MCMethodDefinition methodsFor: '*xpf-codetalk' stamp: 'mt 3/24/2009 15:52'!
sourceText: aText

	sourceText := aText.! !

MultiNewParagraph subclass: #XpfParagraph
	instanceVariableNames: 'textMorph showLineNumbers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/1/2009 15:00'!
addAttributeMorphs
	"Add the small iconmorphs that appear for some attributes in the text."
	
	| morphs |
	selectionStart isNil | self textMorph isNil
		ifTrue: [^ self].

	morphs := (self text
		attributesOfKind: XpfComplexAttribute 
		from: selectionStart textLine first
		to: selectionStart textLine last)
		collect: [:attr | self textMorph addMorph: attr morph. attr morph].
	self textMorph removeAllMorphsBut: morphs.! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/1/2009 16:15'!
displayOn: aCanvas using: displayScanner at: somePosition

	self
		updateProperties;
		addAttributeMorphs;
		drawLineNumberBorderOn: aCanvas.
	
	(self lineIndexForPoint: aCanvas clipRect topLeft)
		to: (self lineIndexForPoint: aCanvas clipRect bottomRight)
		do: [ :i | | line |
			line := lines at: i.
			self drawComplexAttributeOn: aCanvas at: i.
			self drawLineNumber: i on: aCanvas for: line].
	
	super displayOn: aCanvas using: displayScanner at: somePosition.! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/1/2009 16:14'!
drawComplexAttributeOn: aCanvas at: index 

	| textLine line nextLine|
	line := lines at: index.
	nextLine := lines size > index ifTrue: [lines at: index + 1] ifFalse: [].
	textLine := self text 
		copyFrom: line first
		to: line last.
	textLine runs withStartStopAndValueDo: [:start :stop :attributes |
		(attributes 
			detect: [:attr | attr isKindOf: XpfComplexAttribute]
			ifNone: [])
			ifNotNilDo: [:cAttr | | cb1 cb2 |
				cb1 := self characterBlockForIndex: start + (line first - 1).
				cb2 := self characterBlockForIndex: stop + (line first - 1).
	
				"Highlight the attribute."
				cAttr
					displayOn: aCanvas
					in: (cb1 left @ line top corner: cb2 right @ line bottom).

				"Update position of the morph from the attribute."
				(self isLastOccuranceOf: cAttr in: textLine position: stop for: index)
					ifTrue: [cAttr morph position: cb2 right @ (line top - cAttr morph height)]]].! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/1/2009 16:15'!
drawLineNumber: aNumber on: aCanvas for: line

	| str |
	showLineNumbers ifFalse: [^ self].
	self textMorph ifNil: [^ self].
	
	str := (aNumber < 10 ifTrue: [' '] ifFalse: ['']), aNumber asString.
	aCanvas
		drawString: str
		from: 1
		to: str size
		at: (self textMorph position x @ (line top + 2))
		font: Preferences standardCodeFont
		color: ((self isInSelectionFor: line)
			ifTrue: [Color black]
			ifFalse: [Color gray]).! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/1/2009 16:12'!
drawLineNumberBorderOn: aCanvas

	| fontWidth |
	showLineNumbers ifFalse: [^ self].
	self textMorph ifNil: [^ self].
	
	fontWidth := Preferences standardCodeFont widthOfString: '99'.
	aCanvas
		line: (self textMorph position x + fontWidth + 3) @ aCanvas clipRect top
		to: (self textMorph position x + fontWidth + 3) @ aCanvas clipRect bottom
		width: 1
		color: Color gray.! !

!XpfParagraph methodsFor: 'testing' stamp: 'mt 5/1/2009 13:39'!
isInSelectionFor: line

	(selectionStart isNil or: [selectionStop isNil])
		ifTrue: [^ false].
		
	^ line last >= selectionStart textLine first
		and: [line first <= selectionStop textLine last]! !

!XpfParagraph methodsFor: 'testing' stamp: 'mt 5/1/2009 15:31'!
isLastOccuranceOf: cAttr in: textLine position: endOfRunIndex for: lineIndex
	"Answer true if the attribute does not appear in another run past the current one."

	| nextLine |
	nextLine := lines size > lineIndex ifTrue: [lines at: lineIndex + 1] ifFalse: [].
	^ ((nextLine isNil
		or: [((self text attributesAt: nextLine first) noneSatisfy: [:att | att == cAttr])])
		and: [textLine runs size < (endOfRunIndex + 1) 
			or: [(textLine attributesAt: endOfRunIndex + 1)	noneSatisfy: [:att | att == cAttr]]])! !

!XpfParagraph methodsFor: 'editing' stamp: 'cs 5/2/2009 13:47'!
tagSelectionWith: aSymbol
	"Tag the selected code or text with the symbol."

	| attribute |
	attribute := XpfComplexAttribute forTag: aSymbol.
	attribute addDependent: self textMorph.
	selectionStart = selectionStop ifTrue: [^ false].
	self text
		addAttribute: attribute
		from: selectionStart stringIndex
		to: selectionStop stringIndex - 1.
	^ true! !

!XpfParagraph methodsFor: 'accessing' stamp: 'mt 4/22/2009 20:37'!
textMorph
	^ textMorph! !

!XpfParagraph methodsFor: 'accessing' stamp: 'mt 4/22/2009 20:37'!
textMorph: anObject
	textMorph := anObject! !

!XpfParagraph methodsFor: 'editing' stamp: 'mt 5/1/2009 16:02'!
untagSelection

	(self text
		attributesOfKind: XpfComplexAttribute
		from: selectionStart stringIndex
		to: selectionStop stringIndex) do: [:attr |
			self text
				removeAttribute: attr
				around: selectionStart stringIndex
				and: selectionStop stringIndex - 1].! !

!XpfParagraph methodsFor: 'accessing' stamp: 'mt 5/1/2009 16:16'!
updateProperties

	showLineNumbers ifNil: [showLineNumbers := 
		(Preferences
			preferenceAt: #showLineNumbers
			ifAbsent: [Preference new rawValue: false])
			preferenceValue].! !

OBCommand subclass: #XpfCtCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

XpfCtCommand subclass: #XpfCtCmdJustTalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdJustTalk methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 09:40'!
icon

	^ #xpfCtCommentsIcon! !

!XpfCtCmdJustTalk methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 09:37'!
label

	^ 'add code chat'! !

!XpfCtCmdJustTalk methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 09:37'!
mark: aTarget in: anEditor

	^ anEditor justTalk: aTarget! !

XpfCtCommand subclass: #XpfCtCmdMarkBad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdMarkBad methodsFor: 'accessing' stamp: 'mt 2/5/2009 18:09'!
icon
	^#markBadIcon! !

!XpfCtCmdMarkBad methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:12'!
keystroke
	^ $B! !

!XpfCtCmdMarkBad methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:11'!
label
	^ 'mark bad'! !

!XpfCtCmdMarkBad methodsFor: 'editor-bridge' stamp: 'mt 5/1/2009 16:00'!
mark: aTarget in: anEditor

	^ anEditor markAsBad: aTarget.! !

XpfCtCommand subclass: #XpfCtCmdMarkGood
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdMarkGood methodsFor: 'accessing' stamp: 'cs 3/18/2009 15:27'!
icon

	^ #markGoodIcon! !

!XpfCtCmdMarkGood methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:20'!
keystroke
	^ $G! !

!XpfCtCmdMarkGood methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:20'!
label
	^ 'mark good'! !

!XpfCtCmdMarkGood methodsFor: 'editor-bridge' stamp: 'mt 5/1/2009 16:00'!
mark: aTarget in: anEditor

	^ anEditor markAsGood: aTarget! !

XpfCtCommand subclass: #XpfCtCmdMarkUnclear
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdMarkUnclear methodsFor: 'accessing' stamp: 'cs 3/18/2009 15:27'!
icon

	^ #markUnknownIcon! !

!XpfCtCmdMarkUnclear methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:24'!
keystroke
	^ $U! !

!XpfCtCmdMarkUnclear methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:24'!
label
	^ 'mark unclear'! !

!XpfCtCmdMarkUnclear methodsFor: 'editor-bridge' stamp: 'mt 5/1/2009 16:00'!
mark: aTarget in: anEditor

	^ anEditor markAsUnclear: aTarget! !

XpfCtCommand subclass: #XpfCtCmdRemoveMarkup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdRemoveMarkup methodsFor: 'as yet unclassified' stamp: 'cs 3/18/2009 15:27'!
icon

	^ #removeMarkupIcon! !

!XpfCtCmdRemoveMarkup methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2009 10:06'!
isEnabled

	^ true "target text includesAttributesOfKind: XpfComplexAttribute"! !

!XpfCtCmdRemoveMarkup methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:46'!
label
	^'remove markup'! !

!XpfCtCmdRemoveMarkup methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 16:00'!
mark: aTarget in: anEditor
	
	anEditor removeMarkup: aTarget.
	^ true! !

!XpfCtCommand class methodsFor: 'testing' stamp: 'cs 5/2/2009 13:30'!
takesText

	^ true! !

!XpfCtCommand methodsFor: 'accessing' stamp: 'cs 5/2/2009 13:31'!
cluster

	^ #CodeTalk! !

!XpfCtCommand methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 13:32'!
execute
	"'inspired' by ORCmdPrettyPrint>>execute"

	| panel morph editor |	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	editor := morph textMorph editor.
	morph hasUnacceptedEdits: (self mark: target in: editor).! !

!XpfCtCommand methodsFor: 'testing' stamp: 'mt 5/2/2009 09:59'!
isActive

	^ target isKindOf: OBTextSelection! !

!XpfCtCommand methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 13:32'!
mark: aTarget in: anEditor

	^ self subclassResponsibility! !

TextAttribute subclass: #XpfComplexAttribute
	instanceVariableNames: 'tag chat chatMorph deleteMorph morph creator timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

XpfComplexAttribute class
	instanceVariableNames: 'colorTable'!

XpfComplexAttribute class
	instanceVariableNames: 'colorTable'!

!XpfComplexAttribute class methodsFor: 'color mapping' stamp: 'mt 5/2/2009 09:19'!
colorForTag: aSymbol

	colorTable ifNil: [colorTable := Dictionary newFrom: {
		#good -> (Color green alpha: 0.4).
		#bad -> (Color red alpha: 0.4).
		#unclear -> (Color gray alpha: 0.4).
		#talk -> (Color yellow alpha: 0.4)}].
	
	^ colorTable at: aSymbol ifAbsent: [Color transparent]! !

!XpfComplexAttribute class methodsFor: 'instance creation' stamp: 'mt 5/2/2009 16:11'!
forTag: aSymbol

	^ self new
		tag: aSymbol;
		timestamp: TimeStamp now;
		creator: Utilities authorInitials! !

!XpfComplexAttribute class methodsFor: 'caching' stamp: 'mt 5/1/2009 14:30'!
reset
	"Free all cached values."
	
	colorTable := nil.! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 4/30/2009 11:41'!
scanChatFrom: strm for: attribute

	| chatCopy |
	chatCopy := Json readFrom: (ByteArray fromHexString: (strm upTo: $-)) asString readStream.
	chatCopy do: [:line |
		line at: #timestamp put: (TimeStamp fromString: (line at: #timestamp))].
	attribute chat: chatCopy asOrderedCollection.! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 5/2/2009 15:57'!
scanCreatorFrom: strm for: attribute

	attribute creator: (ByteArray fromHexString: (strm upTo: $-)) asString.! !

!XpfComplexAttribute class methodsFor: 'instance creation' stamp: 'mt 5/2/2009 16:06'!
scanFrom: strm

	| instance substream |
	instance := self new.
	substream := (strm upTo: $#) readStream.
	self
		scanTimestampFrom: substream for: instance;
		scanTagFrom: substream for: instance;
		scanTagFrom: substream for: instance;
		scanChatFrom: substream for: instance.
	^ instance! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 5/1/2009 14:37'!
scanTagFrom: strm for: attribute

	attribute tag: (strm upTo: $-) asSymbol.! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 5/2/2009 15:57'!
scanTimestampFrom: strm for: attribute

	attribute timestamp: (TimeStamp fromString:
		(ByteArray fromHexString: (strm upTo: $-)) asString).! !

!XpfComplexAttribute methodsFor: 'testing' stamp: 'mt 4/30/2009 16:08'!
= other

	^ self == other! !

!XpfComplexAttribute methodsFor: 'chat' stamp: 'mt 4/30/2009 17:06'!
addChatLine: aString

	self chat add: (Dictionary newFrom: {
		#author -> Utilities authorInitials.
		#timestamp -> TimeStamp now.
		#message -> aString}).
	self changed: #chatLineAdded.! !

!XpfComplexAttribute methodsFor: 'chat' stamp: 'mt 4/30/2009 17:08'!
addDependent: anObject

	(self dependents includes: anObject)
		ifTrue: [^ self].
		
	^ super addDependent: anObject.! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 4/29/2009 21:51'!
chat

	chat ifNil: [chat := OrderedCollection new].
	^ chat! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 4/30/2009 11:15'!
chat: aCollection

	chat := aCollection.! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/1/2009 17:11'!
chatMorph

	chatMorph ifNil: [chatMorph := XpfCtChatIconMorph new attribute: self].
	^ chatMorph! !

!XpfComplexAttribute methodsFor: 'html' stamp: 'mt 5/1/2009 15:05'!
closeHtmlOn: aStream 
	"put on the given stream the tag to close the html  
	representation of the receiver"
	aStream nextPutAll: '</span>'! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/1/2009 14:31'!
color

	^ self class colorForTag: self tag! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:47'!
creator

	creator ifNil: [creator := Utilities authorInitials].
	^ creator! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:44'!
creator: authorInitials

	creator := authorInitials.! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/1/2009 17:24'!
deleteMorph

	deleteMorph ifNil: [deleteMorph := XpfCtDeleteIconMorph new attribute: self].
	^ deleteMorph! !

!XpfComplexAttribute methodsFor: 'displaying' stamp: 'mt 5/1/2009 15:37'!
displayOn: aCanvas in: drawBounds
	"Show some stuff on the canvas for this attribute."
	
	aCanvas
		fillRectangle: drawBounds
		color: self color.! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/1/2009 17:28'!
morph

	morph ifNil: [morph := XpfCtRowMorph for: {
		self chatMorph.
		self deleteMorph}].
	^ morph! !

!XpfComplexAttribute methodsFor: 'html' stamp: 'mt 5/1/2009 15:05'!
openHtmlOn: aStream 
	"put on the given stream the tag to open the html  
	representation of the receiver"
	aStream nextPutAll: '<span>'! !

!XpfComplexAttribute methodsFor: 'event handling' stamp: 'mt 5/1/2009 17:33'!
requestDeletion

	self changed: #deleteRequested with: self.! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/1/2009 14:31'!
tag

	^ tag! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/1/2009 14:38'!
tag: aSymbol
	"Tag this attribute. Different tags allows to display this attribute in different ways."

	tag := (aSymbol = #'0') ifTrue: [] ifFalse: [aSymbol].! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:47'!
timestamp

	timestamp ifNil: [timestamp := TimeStamp now].
	^ timestamp! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:45'!
timestamp: aTimeStamp

	timestamp := aTimeStamp.! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/2/2009 15:51'!
writeChatOn: strm

	| chatCopy |
	chatCopy := self chat collect: [:line |
		Dictionary newFrom: {
			#timestamp -> (line at: #timestamp) printString.
			#author -> (line at: #author).
			#message -> (line at: #message)}].
	strm nextPutAll: (Json render: chatCopy) toHex.
	strm nextPut: $-.! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/2/2009 15:52'!
writeCreatorOn: strm

	strm nextPutAll: self creator toHex.
	strm nextPut: $-.! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/2/2009 15:58'!
writeScanOn: strm

	strm nextPut: $h.
	self
		writeTimestampOn: strm;
		writeCreatorOn: strm;
		writeTagOn: strm;
		writeChatOn: strm.
	strm nextPut: $#. "mark end of attribute stream"! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/1/2009 14:34'!
writeTagOn: strm

	strm nextPutAll: (self tag ifNil: [$0]).
	strm nextPut: $-.! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/2/2009 16:08'!
writeTimestampOn: strm

	strm nextPutAll: self timestamp printString toHex.
	strm nextPut: $-.! !

StandardWindow subclass: #XpfCtTagSearchMorph
	instanceVariableNames: 'textEntry searchButton resultsList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtTagSearchMorph methodsFor: 'as yet unclassified' stamp: 'cs 5/2/2009 15:06'!
initialize
	super initialize.
	self
		model: XpfCtTagSearchHelper new;
		initializeUserInterface! !
XpfCodeTalk initialize!
